import fs from 'fs'
import ejs from 'ejs'
import path from 'path'
import { fileURLToPath } from 'url'
import prettier from 'prettier'

// appTemplate参数模板
var obj = {
  static: false,
  cors: false,
  morgan: false
}
// 配置appTemplate参数
function getAppConfig(arrArg) {
  arrArg.forEach(element => {
    obj[element] = !obj[element]
  })
}
const __dirname = fileURLToPath(import.meta.url)
// 读取app.js文件的内容
export function appTemplate(arr, port) {
  getAppConfig(arr)
  obj.port = port
  // console.log(obj)
  const app = fs.readFileSync(path.resolve(__dirname, '../template/app.ejs'))
  const appCode = ejs.render(app.toString(), obj)
  return prettier.format(appCode, { parser: 'babel' })
}

// 读取package.json文件的内容
export function packageTemplate(arr, name) {
  obj.name = name
  const packages = fs.readFileSync(path.resolve(__dirname, '../template/package.ejs'))
  const packageCode = ejs.render(packages.toString(), obj)
  return prettier.format(packageCode, { parser: 'json' })
}
