#! /usr/bin/env node
// 文件模块
import fs from 'fs'

// 运行命令的模块
import child_process from 'child_process'

// 第三方删除目录模块
import rimraf from 'rimraf'

// 第三方命令行输出彩色内容模块
import chalk from 'chalk'

// 项目配置
import * as conf from './config.js'

// 获取模板
import * as template from './createTemplate.js'

// 删除原有的目录
rimraf(`${getRootPath()}`, err => {
  if (err) return err
})
// 创建项目的根目录
try {
  fs.mkdirSync(`${getRootPath()}`)
  console.log(chalk.blue(`${conf.conf.Name}`), chalk.yellow('-->'), chalk.green('目录创建成功'))

  // 获取cmd输入的内容
  let config = conf.conf

  try {
    // 创建项目的入口文件
    fs.writeFileSync(`${getRootPath()}/app.js`, template.appTemplate(config.middleware, config.Port))
    console.log(chalk.blue(`app.js`), chalk.yellow('-->'), chalk.green('创建成功'))

    try {
      // 创建项目的package.json文件
      fs.writeFileSync(`${getRootPath()}/package.json`, template.packageTemplate(config.middleware, config.Name))
      console.log(chalk.blue(`package.json`), chalk.yellow('-->'), chalk.green('创建成功'))

      try {
        // 安装依赖
        child_process.exec(`cd ${getRootPath()} && npm install`, (err, result, errResult) => {
          if (!err) {
            console.log(chalk.blue(`依赖下载完成:`), chalk.gray(`${result}`))
            console.log(chalk.green('项目创建成功'))
          } else {
            console.log(chalk.red(`依赖下载失败:`))
          }
        })
      } catch (errorExec) {
        console.log(chalk.red(`${errResult}`))
      }
    } catch (errTemplatePackage) {
      console.log(chalk.red(`package.json创建失败`))
    }
  } catch (errTemplateApp) {
    console.log(chalk.red(`app.js创建失败`))
  }
} catch (error) {
  console.log(chalk.red(`项目创建失败`))
}

// 获取根路径
function getRootPath() {
  let path = conf.conf.Name
  return `./${path}`
}
